
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Swift：用UICollectionView整一个瀑布流 / iVAN</title>

    <meta name="description" content="Swift：用UICollectionView整一个瀑布流 本文的例子和Swift版本是基于Xcode7.2的.以后也许不知道什么时候会更新. 我们要干点啥 用新浪微博的Open API做后端来实现我们要提到的功能.把新浪微博的内容,图片和文字展示在collection view中.本文只简单的展示内容.下篇会用pinterest一样的效果来展示这些内容. 我们准备优先展示图片.你的好友花了那么多时间拍照或者从相册里选择图片发上来多不容易.如果微博返回的数据中有中等大小的缩略图,那么久展示这个缩略图.否则的话显示文本.文本都没有的话...这个就不是微博了">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Swift：用UICollectionView整一个瀑布流</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<pre><code>本文的例子和Swift版本是基于Xcode7.2的。以后也许不知道什么时候会更新。</code></pre>
<h3>我们要干点啥</h3>
<p>用新浪微博的Open API做后端来实现我们要提到的功能。把新浪微博的内容，图片和文字展示在collection view中。本文只简单的展示内容。下篇会用pinterest一样的效果来展示这些内容。</p>
<p>我们准备优先展示图片。你的好友花了那么多时间拍照或者从相册里选择图片发上来多不容易。如果微博返回的数据中有中等大小的缩略图，那么久展示这个缩略图。否则的话显示文本。文本都没有的话。。。这个就不是微博了。但是我们还是会准备一个颜色显示出来。</p>
<h3>啥是UICollectionView</h3>
<p>UICollectionView有一个灵活的布局，可以用各种不同的布局展示数据。 <br />
UICollectionView的使用和UITableView类似，也是需要分别去实现一组datasource的代理和UICollectionView本身的代理来把数据展示在界面中。</p>
<blockquote><pre><code>UICollectionView也是UIScrollView的一个子类</code></pre>
</blockquote>
<p>其他的还有： <br />
1. UICollectionViewCell：这些Cell组成了整个UICollectionView，并作为子View添加到UICollectionView中。可以在Interface builder中创建，也可以代码创建。 <br />
2. Header/Footer：跟UITableView差不多的概念。显示一些title什么的信息。</p>
<blockquote><pre><code>UICollectionView还有一个叫做Decoration view的东西。顾名思义，主要是装饰用的。
不过要用这部分的功能你需要单独写定制的layout。</code></pre>
</blockquote>
<p>除了以上说到的内容之外，collection view还有一个专门处理布局的<code>UICollectionViewLayout</code>。你可以继承<code>UICollectionViewLayout</code>来创建一个自己的collection view的布局。苹果给了一个基础的布局<code>UICollectionViewFlowLayout</code>，可以实现一个基本的流式布局。这些会在稍后的教程中介绍。</p>
<p>开始我们的项目： <br />
首先创建一个single view的应用。 <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjAxMzAxNzEzNDM5MTY=.jpg"></p>
<p>然后给你的项目起一个名字，我们这里就叫做<code>CollectionViewDemo</code>。Storyboard中默认生成的Controller已经木有什么用处了。直接干掉，拖一个<code>UICollectionViewController</code>进去并设置为默认的Controller。并删除默认生成的<strong>ViewController.swift</strong>文件，并创建一个叫做<strong>HomeCollectionViewController.swift</strong>的文件。之后在interface builder中把collection view的类设置为<code>HomeCollectionViewController</code>。</p>
<p>然后： <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjAxMzAxNzIwMTI0MDg=.jpg"></p>
<ol>
<li>在Storyboard中添加一个navigation controller</li>
<li>把collection view设置为上面的navigation controller的root view controller。</li>
<li>把这个navigation controller设置为initial view controller。</li>
</ol>
<p>接下来再次回到collection view controller。这个</p>
<h3>进一步了解UICollectionView</h3>
<p>如前文所述，UICollectionView和UITableView类似，都有datasource和delegate。这样就可以设置datasource和设置一些用户的交互，比如选中某一个cell的时候怎么处理。</p>
<p><code>UICollectionViewFlowLayout</code>有一个代理：<code>UICollectionViewDelegateFlowLayout</code>。通过这个代理可以设定布局的一些行为比如：cell的间隔，collection view的滚动方向等。</p>
<p>下面就开始在我们的代码中给<code>UICollectionViewDataSource</code>和<code>UICollectionViewDelegateFlowLayout</code> 两个代理的方法做一个填空。<code>UICollectionViewDelegate</code>里的方法暂时还用不着，稍后会给这个代理做填空。</p>
<h3>实现UICollectionViewDataSource</h3>
<p>这里我们用微博开放API为例。从微博的开发API上获取到当前用户的全部的微博，然后用UICollectionView展示。获取到的微博time line最后会放在这里：</p>
<table>
<tbody>
<tr>
<td>
<br />1
</td>
<td>
<p><code>private</code> <code>var</code> <code>timeLineStatus</code><code>: [</code><code>StatusModel</code><code>]?</code></p>
</td>
</tr>
</tbody>
</table>
<p>在data source中的代码就很好添加了。</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17
</td>
<td>
<p><code>// MARK: UICollectionViewDataSource</code></p>
<p> </p>
<p><code>    </code><code>override</code> <code>func</code> <code>numberOfSectionsInCollectionView</code><code>(</code><code>collectionView</code><code>: </code><code>UICollectionView</code><code>) -</code><code>&gt;</code> <code>Int</code> <code>{</code></p>
<p><code>        </code><code>return</code> <code>1</code>    <code>//1</code></p>
<p><code>    </code><code>}</code></p>
<p> </p>
<p><code>    </code><code>override</code> <code>func</code> <code>collectionView</code><code>(</code><code>collectionView</code><code>: </code><code>UICollectionView</code><code>, </code><code>numberOfItemsInSection</code> <code>section</code><code>: </code><code>Int</code><code>) -</code><code>&gt;</code> <code>Int</code> <code>{</code></p>
<p><code>        </code><code>return</code> <code>self</code><code>.</code><code>timeLineStatus</code><code>?.</code><code>count</code> <code>?? </code><code>0</code> <code>//2</code></p>
<p><code>    </code><code>}</code></p>
<p> </p>
<p><code>    </code><code>override</code> <code>func</code> <code>collectionView</code><code>(</code><code>collectionView</code><code>: </code><code>UICollectionView</code><code>, </code><code>cellForItemAtIndexPath</code> <code>indexPath</code><code>: </code><code>NSIndexPath</code><code>) -</code><code>&gt;</code> <code>UICollectionViewCell</code> <code>{</code></p>
<p><code>        </code><code>let</code> <code>cell</code> <code>= </code><code>collectionView</code><code>.</code><code>dequeueReusableCellWithReuseIdentifier</code><code>(</code><code>reuseIdentifier</code><code>, </code><code>forIndexPath</code><code>: </code><code>indexPath</code><code>)</code></p>
<p> </p>
<p><code>        </code><code>cell</code><code>.</code><code>backgroundColor</code> <code>= </code><code>UIColor</code><code>.</code><code>orangeColor</code><code>() </code><code>//3</code></p>
<p> </p>
<p><code>        </code><code>return</code> <code>cell</code></p>
<p><code>    </code><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<ol>
<li>我们只要一个section，所以这里返回数字1。</li>
<li>返回的time line都会放在类型为<code>StatusModel</code>的数组里。这个数组可能为空，因为很多情况会影响到网络请求，比如网络不通的时候。这个时候返回的time line就是空了。所以<code>self.timeLineStatus?.count</code>得出的数字也可能是空，那么这个时候就应该返回0。</li>
<li>由于没有合适的Cell返回，现在只好用改变Cell的背景色的方式看到Cell的排布。</li>
</ol>
<p>效果是这样的： <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjAxMzAxNzIyMDEwMDY=.jpg"></p>
<h3>UICollectionViewFlowLayoutDelegate</h3>
<p>这个代理的作用和UITableView的<code>func tableView(tableView: UITableView, heightForRowAtIndexPath indexPath: NSIndexPath) -&gt; CGFloat</code>有非常类似的作用。<code>heightForRowAtIndexPath</code>的作用是返回UITableViewCell的高度。而UICollectionViewCell有非常多的不同的大小，所以需要更加复杂的代理方法的支持。其中包括两个方法：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17
</td>
<td>
<p><code>// 1</code></p>
<p><code>class</code> <code>HomeCollectionViewController</code><code>: </code><code>UICollectionViewController</code><code>, </code><code>UICollectionViewDelegateFlowLayout</code></p>
<p> </p>
<p><code>// 2</code></p>
<p><code>private</code> <code>let</code> <code>sectionInsets</code> <code>= </code><code>UIEdgeInsets</code><code>(</code><code>top</code><code>: </code><code>10.0</code><code>, </code><code>left</code><code>: </code><code>10.0</code><code>, </code><code>bottom</code><code>: </code><code>10.0</code><code>, </code><code>right</code><code>: </code><code>10.0</code><code>)</code></p>
<p> </p>
<p><code>// MARK: UICollectionViewDelegateFlowLayout</code></p>
<p> </p>
<p><code>// 3</code></p>
<p><code>func</code> <code>collectionView</code><code>(</code><code>collectionView</code><code>: </code><code>UICollectionView</code><code>, </code><code>layout</code> <code>collectionViewLayout</code><code>:</code><code>UICollectionViewLayout</code><code>, </code><code>sizeForItemAtIndexPath</code> <code>indexPath</code><code>: </code><code>NSIndexPath</code><code>) -</code><code>&gt;</code> <code>CGSize</code> <code>{</code></p>
<p><code>    </code><code>return</code> <code>CGSize</code><code>(</code><code>width</code><code>: </code><code>170</code><code>, </code><code>height</code><code>: </code><code>300</code><code>)</code></p>
<p><code>}</code></p>
<p> </p>
<p><code>// 4</code></p>
<p><code>func</code> <code>collectionView</code><code>(</code><code>collectionView</code><code>: </code><code>UICollectionView</code><code>, </code><code>layout</code> <code>collectionViewLayout</code><code>: </code><code>UICollectionViewLayout</code><code>, </code><code>insetForSectionAtIndex</code> <code>section</code><code>: </code><code>Int</code><code>) -</code><code>&gt;</code> <code>UIEdgeInsets</code> <code>{</code></p>
<p><code>    </code><code>return</code> <code>sectionInsets</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<ol>
<li>首先需要实现layout的代理<code>UICollectionViewDelegateFlowLayout</code>。</li>
<li>给类添加一个<code>sectionInsets</code>的属性。</li>
<li><code>UICollectionViewDelegateFlowLayout</code>的第一个方法，用来返回<code>indexPath</code>指定位置的Cell的Size。</li>
<li>layout代理的另外一个方法，用来返回每一个section的inset。</li>
</ol>
<p>看看运行效果： <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjAxMzAxNzI0MTcxMTc=.jpg"></p>
<h3>创建自定义UICollectionViewCell</h3>
<p>下面就要处理内容在展示的时候具体应该怎么展示了。我们这里分两种情况，如果用户的微博有图片，那么就展示图片。如果没有图片就展示文字。可惜的是微博的API没有图片的大小返回回来。展示的时候需要大小参数来决定这个 <br /><code>UICollectionViewCell</code>到底要多大的size，由于没有就只好弄个方块来展示图片了。至于图片的拉伸方式就有你来决定了，我们这里为了简单就使用默认的方式拉伸图片。</p>
<p>在文字上就需要根据文字的多少了决定size了。由于我们的宽度是一定的，也就是说在autolayout中<code>UILabel</code>的<code>preferredMaxLayoutWidth</code>是一定的。然后就可以很方便的根据这个宽度来计算多行的<code>UILabel</code>到底需要多少的高度来全部展示微博中的文字。</p>
<p>首先是展示图片的Cell。 <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjAxMzAxNzI1MTUzMTY=.jpg"><br />
在Cell上放一个<code>UIImageView</code>，保证这个image view的四个边距都是0。</p>
<p>创建一个文件<strong>WeiboImageCell.swift</strong>，里面是类<code>WeiboImageCell</code>，继承自<code>UICollectionViewCell</code>。 <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjAxMzAxNzI2MjQ0MDE=.jpg"><br />
把这个Cell的custom class设置为<code>WeiboImageCell</code>。 <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjAxMzAxNzI3MTIzNDA=.jpg"> <br />
然后把Cell代码中的image view和interface builder的image view关联为<strong>IBOutelt</strong>：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3
</td>
<td>
<p><code>class</code> <code>WeiboImageCell</code><code>: </code><code>UICollectionViewCell</code> <code>{</code></p>
<p><code>    </code><code>@IBOutlet</code> <code>weak</code> <code>var</code> <code>weiboImageView</code><code>: </code><code>UIImageView</code><code>!</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>重复上面的步骤添加一个只有一个<code>UILabel</code>的Cell，类型为<code>WeiboTextCell</code>。设置这个<code>UILabel</code>的属性<code>numberOfLines</code>为0，这样就可以显示多行的文字。然后设置这个label的上、左、下、右都是-8。</p>
<blockquote><pre><code>为什么是-8呢，因为苹果默认的给父view留了宽度为8的margin（边距），如果要文字和Cell的边距贴合的话
需要覆盖这个系统预留的边距，因此需要设置边距为-8。</code></pre>
</blockquote>
<p>最后关联代码和label。</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3
</td>
<td>
<p><code>class</code> <code>WeiboTextCell</code><code>: </code><code>UICollectionViewCell</code> <code>{</code></p>
<p><code>    </code><code>@IBOutlet</code> <code>weak</code> <code>var</code> <code>weiboTextLabel</code><code>: </code><code>UILabel</code><code>!</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>添加完这两个Cell之后，回到<code>HomeCollectionViewController</code>。删除<code>self.collectionView!.registerClass(WeiboImageCell.self, forCellWithReuseIdentifier: reuseIdentifier)</code>方法，以及全部的<code>registerClass</code>。</p>
<blockquote><pre><code>`registerClass`, 这个方法的调用会把我们在storyboard里做的一切都给抹掉。在调用Cell里的image view或者label的时候得到的永远是nil。</code></pre>
</blockquote>
<p>到这，我们需要讨论一下text cell对于label的约束问题。首先我们同样设置label的约束，让这个label贴着cell的边。也就是，top、leading、trailing和bottom为-8。</p>
<p>但是这样的而设置让label在显示出来的cell中是居中的。尤其在文字不足够现实满cell的空间的时候。所以，我们需要改一个地方。修改bottom的优先级，设置为low，最低：<code>UILayoutPriorityDefaultLow</code>。这样在labe计算高度的时候会优先考虑的是文字填满label后的高度，而不是像之前一样直接把labe的高度设置为cell的高度。这个时候不论文字是否填满cell，都是从顶开始显示有多少控件用多少空间。</p>
<h3>集成SDWebImage</h3>
<p>我们那什么来拯救图片cell惹？辣就是<code>SDWebImage</code>是一个著名的图片请求和缓存的库。我们这里用这个库来请求微博中的图片并缓存。</p>
<p>添加： <br />
在<strong>Podfile</strong>里添加<code>SDWebImage</code>的pod应用<em>pod ‘SDWebImage’, ‘~&gt;3.7’</em>。当然了之前我们已经添加了<code>user_frameworks!</code>。为什么用这个看原文：</p>
<blockquote><pre><code>You can make CocoaPods integrate to your project via frameworks
 instead of static libraries by specifying use_frameworks!. </code></pre>
</blockquote>
<p>多了就不多说了，需要了解更多的可以看<a href="https://blog.cocoapods.org/CocoaPods-0.36/" rel="external nofollow noreferrer">这里</a>。</p>
<p>pod更新完成之后。引入这个framework。</p>
<table>
<tbody>
<tr>
<td>
<br />1
</td>
<td>
<p><code>import</code> <code>SDWebImage</code></p>
</td>
</tr>
</tbody>
</table>
<p>然后就可以给cell的image view上图片了。</p>
<table>
<tbody>
<tr>
<td>
<br />1
</td>
<td>
<p><code>weiboImageCell</code><code>.</code><code>weiboImageView</code><code>.</code><code>sd_setImageWithURL</code><code>(</code><code>NSURL</code><code>(</code><code>string</code><code>: </code><code>status</code><code>.</code><code>status</code><code>?.</code><code>bmiddlePic</code> <code>?? </code><code>""</code><code>))</code></p>
</td>
</tr>
</tbody>
</table>
<p><code>SDWebImage</code>给image view写了一个category。里面有很多可以调用的方法。比如可以设置一个place holder的image。也就是在image没有下载下来之前可以给image view设置一个默认的图片。</p>
<h3>http请求和数据</h3>
<p>这里只是简单说一下，更过的内容请看<a href="http://blog.csdn.net/future_challenger/article/details/50609844" rel="external nofollow noreferrer">这里</a>。 <br />
下面我们看看微博的Open API能给我们返回什么：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21</p>
<p>22</p>
<p>23</p>
<p>24</p>
<p>25</p>
<p>26</p>
<p>27</p>
<p>28</p>
<p>29</p>
<p>30</p>
<p>31</p>
<p>32</p>
<p>33</p>
<p>34</p>
<p>35</p>
<p>36</p>
<p>37</p>
<p>38</p>
<p>39</p>
<p>40</p>
<p>41</p>
<p>42</p>
<p>43</p>
<p>44</p>
<p>45</p>
<p>46
</td>
<td>
<p><code>{</code></p>
<p><code>    </code><code>"statuses"</code><code>: [</code></p>
<p><code>        </code><code>{</code></p>
<p><code>            </code><code>"created_at"</code><code>: </code><code>"Tue May 31 17:46:55 +0800 2011"</code><code>,</code></p>
<p><code>            </code><code>"id"</code><code>: </code><code>11488058246</code><code>,</code></p>
<p><code>            </code><code>"text"</code><code>: </code><code>"求关注。"</code><code>，</code></p>
<p><code>            </code><code>"source"</code><code>: </code><code>"&lt;a href="</code><code>http</code><code>:</code><code>//weibo.com" rel="nofollow"&gt;新浪微博&lt;/a&gt;",</code></p>
<p><code>            </code><code>"favorited"</code><code>: </code><code>false</code><code>,</code></p>
<p><code>            </code><code>"truncated"</code><code>: </code><code>false</code><code>,</code></p>
<p><code>            </code><code>"in_reply_to_status_id"</code><code>: </code><code>""</code><code>,</code></p>
<p><code>            </code><code>"in_reply_to_user_id"</code><code>: </code><code>""</code><code>,</code></p>
<p><code>            </code><code>"in_reply_to_screen_name"</code><code>: </code><code>""</code><code>,</code></p>
<p><code>            </code><code>"geo"</code><code>: </code><code>null</code><code>,</code></p>
<p><code>            </code><code>"mid"</code><code>: </code><code>"5612814510546515491"</code><code>,</code></p>
<p><code>            </code><code>"reposts_count"</code><code>: </code><code>8</code><code>,</code></p>
<p><code>            </code><code>"comments_count"</code><code>: </code><code>9</code><code>,</code></p>
<p><code>            </code><code>"annotations"</code><code>: [],</code></p>
<p><code>            </code><code>"user"</code><code>: {</code></p>
<p><code>                </code><code>"id"</code><code>: </code><code>1404376560</code><code>,</code></p>
<p><code>                </code><code>"screen_name"</code><code>: </code><code>"zaku"</code><code>,</code></p>
<p><code>                </code><code>"name"</code><code>: </code><code>"zaku"</code><code>,</code></p>
<p><code>                </code><code>"province"</code><code>: </code><code>"11"</code><code>,</code></p>
<p><code>                </code><code>"city"</code><code>: </code><code>"5"</code><code>,</code></p>
<p><code>                </code><code>"location"</code><code>: </code><code>"北京 朝阳区"</code><code>,</code></p>
<p><code>                </code><code>"description"</code><code>: </code><code>"人生五十年，乃如梦如幻；有生斯有死，壮士复何憾。"</code><code>,</code></p>
<p><code>                </code><code>"url"</code><code>: </code><code>"<a href="http://blog.sina.com.cn/zaku" rel="external nofollow noreferrer">http://blog.sina.com.cn/zaku</a>"</code><code>,</code></p>
<p><code>                </code><code>"profile_image_url"</code><code>: </code><code>"<a href="http://tp1.sinaimg.cn/1404376560/50/0/1" rel="external nofollow noreferrer">http://tp1.sinaimg.cn/1404376560/50/0/1</a>"</code><code>,</code></p>
<p><code>                </code><code>"domain"</code><code>: </code><code>"zaku"</code><code>,</code></p>
<p><code>                </code><code>"gender"</code><code>: </code><code>"m"</code><code>,</code></p>
<p><code>                </code><code>"followers_count"</code><code>: </code><code>1204</code><code>,</code></p>
<p><code>                </code><code>...</code></p>
<p><code>            </code><code>}</code></p>
<p><code>        </code><code>},</code></p>
<p><code>        </code><code>...</code></p>
<p><code>    </code><code>],</code></p>
<p><code>    </code><code>"ad"</code><code>: [</code></p>
<p><code>        </code><code>{</code></p>
<p><code>            </code><code>"id"</code><code>: </code><code>3366614911586452</code><code>,</code></p>
<p><code>            </code><code>"mark"</code><code>: </code><code>"AB21321XDFJJK"</code></p>
<p><code>        </code><code>},</code></p>
<p><code>        </code><code>...</code></p>
<p><code>    </code><code>],</code></p>
<p><code>    </code><code>"previous_cursor"</code><code>: </code><code>0</code><code>,      </code><code>// 暂时不支持</code></p>
<p><code>    </code><code>"next_cursor"</code><code>: </code><code>11488013766</code><code>,     </code><code>// 暂时不支持</code></p>
<p><code>    </code><code>"total_number"</code><code>: </code><code>81655</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>我们只需要我们follow的好友的微博的图片或者文字。所以由这些内容我们可以定义出对应的model类。</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21
</td>
<td>
<p><code>import</code> <code>ObjectMapper</code></p>
<p> </p>
<p><code>class</code> <code>BaseModel</code><code>: </code><code>Mappable</code> <code>{</code></p>
<p><code>    </code><code>var</code> <code>previousCursor</code><code>: </code><code>Int</code><code>?</code></p>
<p><code>    </code><code>var</code> <code>nextCursor</code><code>: </code><code>Int</code><code>?</code></p>
<p><code>    </code><code>var</code> <code>hasVisible</code><code>: </code><code>Bool</code><code>?</code></p>
<p><code>    </code><code>var</code> <code>statuses</code><code>: [</code><code>StatusModel</code><code>]?</code></p>
<p><code>    </code><code>var</code> <code>totalNumber</code><code>: </code><code>Int</code><code>?</code></p>
<p> </p>
<p><code>    </code><code>required</code> <code>init</code><code>?(</code><code>_</code> <code>map</code><code>: </code><code>Map</code><code>) {</code></p>
<p> </p>
<p><code>    </code><code>}</code></p>
<p> </p>
<p><code>    </code><code>func</code> <code>mapping</code><code>(</code><code>map</code><code>: </code><code>Map</code><code>) {</code></p>
<p><code>        </code><code>previousCursor</code> <code>&lt;</code><code>- </code><code>map</code><code>[</code><code>"previous_cursor"</code><code>]</code></p>
<p><code>        </code><code>nextCursor</code> <code>&lt;</code><code>- </code><code>map</code><code>[</code><code>"next_cursor"</code><code>]</code></p>
<p><code>        </code><code>hasVisible</code> <code>&lt;</code><code>- </code><code>map</code><code>[</code><code>"hasvisible"</code><code>]</code></p>
<p><code>        </code><code>statuses</code> <code>&lt;</code><code>- </code><code>map</code><code>[</code><code>"statuses"</code><code>]</code></p>
<p><code>        </code><code>totalNumber</code> <code>&lt;</code><code>- </code><code>map</code><code>[</code><code>"total_number"</code><code>]</code></p>
<p><code>    </code><code>}</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>和</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21</p>
<p>22</p>
<p>23</p>
<p>24
</td>
<td>
<p><code>import</code> <code>ObjectMapper</code></p>
<p> </p>
<p><code>class</code> <code>StatusModel</code><code>: </code><code>BaseModel</code> <code>{</code></p>
<p><code>    </code><code>var</code> <code>statusId</code><code>: </code><code>String</code><code>?</code></p>
<p><code>    </code><code>var</code> <code>thumbnailPic</code><code>: </code><code>String</code><code>?</code></p>
<p><code>    </code><code>var</code> <code>bmiddlePic</code><code>: </code><code>String</code><code>?</code></p>
<p><code>    </code><code>var</code> <code>originalPic</code><code>: </code><code>String</code><code>?</code></p>
<p><code>    </code><code>var</code> <code>weiboText</code><code>: </code><code>String</code><code>?</code></p>
<p><code>    </code><code>var</code> <code>user</code><code>: </code><code>WBUserModel</code><code>?</code></p>
<p> </p>
<p><code>    </code><code>required</code> <code>init</code><code>?(</code><code>_</code> <code>map</code><code>: </code><code>Map</code><code>) {</code></p>
<p><code>        </code><code>super</code><code>.</code><code>init</code><code>(</code><code>map</code><code>)</code></p>
<p> </p>
<p><code>    </code><code>}</code></p>
<p> </p>
<p><code>    </code><code>override</code> <code>func</code> <code>mapping</code><code>(</code><code>map</code><code>: </code><code>Map</code><code>) {</code></p>
<p><code>        </code><code>super</code><code>.</code><code>mapping</code><code>(</code><code>map</code><code>)</code></p>
<p><code>        </code><code>statusId</code> <code>&lt;</code><code>- </code><code>map</code><code>[</code><code>"id"</code><code>]</code></p>
<p><code>        </code><code>thumbnailPic</code> <code>&lt;</code><code>- </code><code>map</code><code>[</code><code>"thumbnail_pic"</code><code>]</code></p>
<p><code>        </code><code>bmiddlePic</code> <code>&lt;</code><code>- </code><code>map</code><code>[</code><code>"bmiddle_pic"</code><code>]</code></p>
<p><code>        </code><code>originalPic</code> <code>&lt;</code><code>- </code><code>map</code><code>[</code><code>"original_pic"</code><code>]</code></p>
<p><code>        </code><code>weiboText</code> <code>&lt;</code><code>- </code><code>map</code><code>[</code><code>"text"</code><code>]</code></p>
<p><code>    </code><code>}</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>其中内容全部都放在类<code>StatusModel</code>中，图片我们用属性<code>bmiddlePic</code>，文字用<code>weiboText</code>。其他属性留着以后使用。</p>
<p>请求完成以后，这些time line的微博会存在一个属性里做为数据源使用。</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14
</td>
<td>
<p><code>class</code> <code>HomeCollectionViewController</code><code>: </code><code>UICollectionViewController</code><code>, </code><code>UICollectionViewDelegateFlowLayout</code> <code>{</code></p>
<p><code>  </code><code>private</code> <code>var</code> <code>timeLineStatus</code><code>: [</code><code>StatusModel</code><code>]?  </code><code>// 1</code></p>
<p> </p>
<p><code>  </code><code>//2</code></p>
<p><code>  </code><code>Alamofire</code><code>.</code><code>request</code><code>(.</code><code>GET</code><code>, </code><code>"<a href="https://api.weibo.com/2/statuses/friends_timeline.json" rel="external nofollow noreferrer">https://api.weibo.com/2/statuses/friends_timeline.json</a>"</code><code>, </code><code>parameters</code><code>: </code><code>parameters</code><code>, </code><code>encoding</code><code>: .</code><code>URL</code><code>, </code><code>headers</code><code>: </code><code>nil</code><code>)</code></p>
<p><code>                </code><code>.</code><code>responseString</code><code>(</code><code>completionHandler</code><code>: {</code><code>response</code> <code>in</code></p>
<p><code>                    </code><code>let</code> <code>statuses</code> <code>= </code><code>Mapper</code><code>&lt;</code><code>BaseModel</code><code>&gt;</code><code>().</code><code>map</code><code>(</code><code>response</code><code>.</code><code>result</code><code>.</code><code>value</code><code>)</code></p>
<p> </p>
<p><code>                    </code><code>if</code> <code>let</code> <code>timeLine</code> <code>= </code><code>statuses</code> <code>where</code> <code>timeLine</code><code>.</code><code>totalNumber</code> <code>&gt;</code> <code>0</code> <code>{</code></p>
<p><code>                        </code><code>self</code><code>.</code><code>timeLineStatus</code> <code>= </code><code>timeLine</code><code>.</code><code>statuses</code> <code>// 3</code></p>
<p><code>                        </code><code>self</code><code>.</code><code>collectionView</code><code>?.</code><code>reloadData</code><code>()</code></p>
<p><code>                    </code><code>}</code></p>
<p><code>            </code><code>})</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<ol>
<li>存放数据源的属性。</li>
<li><code>Alamofire</code>发出http请求。</li>
<li>请求成功之后解析数据，并把我们需要的微博数据存放在属性<code>self.timeLineStatus</code>。</li>
</ol>
<p>在展示数据的时候需要区分微博的图片是否存在，存在则优先展示图片，否则展示文字。</p>
<p>一个不怎么好的做法是在方法cell for collection view里判断数据源是否存在，遍历每一个数据源的item判断这个item是否有图片。。。</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6
</td>
<td>
<p><code>override</code> <code>func</code> <code>collectionView</code><code>(</code><code>collectionView</code><code>: </code><code>UICollectionView</code><code>, </code><code>cellForItemAtIndexPath</code> <code>indexPath</code><code>: </code><code>NSIndexPath</code><code>) -</code><code>&gt;</code> <code>UICollectionViewCell</code> <code>{</code></p>
<p><code>  </code><code>if</code> <code>let</code> <code>statuses</code> <code>= </code><code>self</code><code>.</code><code>timeLineStatus</code> <code>{</code></p>
<p><code>    </code><code>let</code> <code>status</code> <code>= </code><code>statuses</code><code>[</code><code>indexPath</code><code>.</code><code>item</code><code>]</code></p>
<p><code>    </code><code>if</code> <code>status</code></p>
<p><code>  </code><code>}</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>这样显然太过冗长了，所以我们要把这一部分代码提升出来。</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21
</td>
<td>
<p><code>/**</code></p>
<p><code>     </code><code>get status and if this status has image or not</code></p>
<p><code>     </code><code>@return:</code></p>
<p><code>        </code><code>status, one of the timeline</code></p>
<p><code>        </code><code>Int, 1: there's image, 0: there's no image, -1: empty status</code></p>
<p><code>     </code><code>*/</code></p>
<p><code>    </code><code>func</code> <code>getWeiboStatus</code><code>(</code><code>indexPath</code><code>: </code><code>NSIndexPath</code><code>) -</code><code>&gt;</code> <code>(</code><code>status</code><code>: </code><code>StatusModel</code><code>?, </code><code>hasImage</code><code>: </code><code>Int</code><code>) {  </code><code>// 1</code></p>
<p><code>        </code><code>if</code> <code>let</code> <code>timeLineStatusList</code> <code>= </code><code>self</code><code>.</code><code>timeLineStatus</code> <code>where</code> <code>timeLineStatusList</code><code>.</code><code>count</code> <code>&gt;</code> <code>0</code> <code>{</code></p>
<p><code>            </code><code>let</code> <code>status</code> <code>= </code><code>timeLineStatusList</code><code>[</code><code>indexPath</code><code>.</code><code>item</code><code>]</code></p>
<p><code>            </code><code>if</code> <code>let</code> <code>middlePic</code> <code>= </code><code>status</code><code>.</code><code>bmiddlePic</code> <code>where</code> <code>middlePic</code> <code>!= </code><code>""</code> <code>{</code></p>
<p><code>                </code><code>// there's middle sized image to show</code></p>
<p><code>                </code><code>return</code> <code>(</code><code>status</code><code>, </code><code>1</code><code>)</code></p>
<p> </p>
<p><code>            </code><code>} </code><code>else</code> <code>{</code></p>
<p><code>                </code><code>// start to consider text</code></p>
<p><code>                </code><code>return</code> <code>(</code><code>status</code><code>, </code><code>0</code><code>)</code></p>
<p><code>            </code><code>}</code></p>
<p><code>        </code><code>}</code></p>
<p> </p>
<p><code>        </code><code>return</code> <code>(</code><code>nil</code><code>, -</code><code>1</code><code>)</code></p>
<p><code>    </code><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>swift是可以在一个方法里返回多个值的。这个多个内容的值用<code>tuple</code>来存放。调用时这样的：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4
</td>
<td>
<p><code>let</code> <code>status</code> <code>= </code><code>self</code><code>.</code><code>getWeiboStatus</code><code>(</code><code>indexPath</code><code>)</code></p>
<p><code>let</code> <code>hasImage</code> <code>= </code><code>status</code><code>?.</code><code>hasImage</code>              <code>// if there's a image</code></p>
<p><code>let</code> <code>imageUrl</code> <code>= </code><code>status</code><code>.</code><code>status</code><code>?.</code><code>bmiddlePic</code>     <code>// image path</code></p>
<p><code>let</code> <code>text</code> <code>= </code><code>status</code><code>.</code><code>status</code><code>?.</code><code>weiboText</code>          <code>// text</code></p>
</td>
</tr>
</tbody>
</table>
<p>只要通过<code>let hasImage = status?.hasImage</code>就可以判断是否有图片。所以Swift的这一点还是非常方便的。那么在判断要显示哪一种Cell的时候就非常的方便了。修改后的代码也非常的简洁。这个习惯需要一直保持下去。</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21</p>
<p>22</p>
<p>23</p>
<p>24</p>
<p>25</p>
<p>26</p>
<p>27</p>
<p>28</p>
<p>29</p>
<p>30
</td>
<td>
<p><code>override</code> <code>func</code> <code>collectionView</code><code>(</code><code>collectionView</code><code>: </code><code>UICollectionView</code><code>, </code><code>cellForItemAtIndexPath</code> <code>indexPath</code><code>: </code><code>NSIndexPath</code><code>) -</code><code>&gt;</code> <code>UICollectionViewCell</code> <code>{</code></p>
<p><code>        </code><code>let</code> <code>status</code> <code>= </code><code>self</code><code>.</code><code>getWeiboStatus</code><code>(</code><code>indexPath</code><code>)</code></p>
<p><code>        </code><code>var</code> <code>cell</code><code>: </code><code>UICollectionViewCell</code> <code>= </code><code>UICollectionViewCell</code><code>()</code></p>
<p> </p>
<p><code>        </code><code>guard</code> <code>let</code> <code>_</code> <code>= </code><code>status</code><code>.</code><code>status</code> <code>else</code> <code>{</code></p>
<p><code>            </code><code>cell</code><code>.</code><code>backgroundColor</code> <code>= </code><code>UIColor</code><code>.</code><code>darkTextColor</code><code>()</code></p>
<p><code>            </code><code>return</code> <code>cell</code></p>
<p><code>        </code><code>}</code></p>
<p> </p>
<p><code>        </code><code>if</code> <code>status</code><code>.</code><code>hasImage</code> <code>== </code><code>1</code> <code>{</code></p>
<p><code>            </code><code>cell</code> <code>= </code><code>collectionView</code><code>.</code><code>dequeueReusableCellWithReuseIdentifier</code><code>(</code><code>reuseIdentifier</code><code>, </code><code>forIndexPath</code><code>: </code><code>indexPath</code><code>)</code></p>
<p><code>            </code><code>let</code> <code>weiboImageCell</code> <code>= </code><code>cell</code> <code>as</code><code>! </code><code>WeiboImageCell</code></p>
<p><code>            </code><code>weiboImageCell</code><code>.</code><code>weiboImageView</code><code>.</code><code>backgroundColor</code> <code>= </code><code>UIColor</code><code>.</code><code>blueColor</code><code>()</code></p>
<p><code>            </code><code>weiboImageCell</code><code>.</code><code>weiboImageView</code><code>.</code><code>sd_setImageWithURL</code><code>(</code><code>NSURL</code><code>(</code><code>string</code><code>: </code><code>status</code><code>.</code><code>status</code><code>?.</code><code>bmiddlePic</code> <code>?? </code><code>""</code><code>))</code></p>
<p> </p>
<p><code>        </code><code>} </code><code>else</code> <code>if</code> <code>status</code><code>.</code><code>hasImage</code> <code>== </code><code>0</code> <code>{</code></p>
<p><code>            </code><code>cell</code> <code>= </code><code>collectionView</code><code>.</code><code>dequeueReusableCellWithReuseIdentifier</code><code>(</code><code>reuseTextIdentifier</code><code>, </code><code>forIndexPath</code><code>: </code><code>indexPath</code><code>)</code></p>
<p><code>            </code><code>let</code> <code>weiboTextCell</code> <code>= </code><code>cell</code> <code>as</code><code>! </code><code>WeiboTextCell</code></p>
<p><code>            </code><code>weiboTextCell</code><code>.</code><code>setCellWidth</code><code>(</code><code>self</code><code>.</code><code>cellWidth</code><code>)</code></p>
<p><code>            </code><code>weiboTextCell</code><code>.</code><code>weiboTextLabel</code><code>.</code><code>text</code> <code>= </code><code>status</code><code>.</code><code>status</code><code>?.</code><code>weiboText</code> <code>?? </code><code>""</code></p>
<p><code>            </code><code>weiboTextCell</code><code>.</code><code>contentView</code><code>.</code><code>backgroundColor</code> <code>= </code><code>UIColor</code><code>.</code><code>orangeColor</code><code>()</code></p>
<p><code>            </code><code>weiboTextCell</code><code>.</code><code>weiboTextLabel</code><code>.</code><code>backgroundColor</code> <code>= </code><code>UIColor</code><code>.</code><code>redColor</code><code>()</code></p>
<p><code>        </code><code>} </code><code>else</code> <code>{</code></p>
<p><code>            </code><code>cell</code> <code>= </code><code>UICollectionViewCell</code><code>()</code></p>
<p><code>        </code><code>}</code></p>
<p> </p>
<p><code>        </code><code>cell</code><code>.</code><code>backgroundColor</code> <code>= </code><code>UIColor</code><code>.</code><code>orangeColor</code><code>() </code><code>//3</code></p>
<p> </p>
<p><code>        </code><code>return</code> <code>cell</code></p>
<p><code>    </code><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>跑起来，看看运行效果。 <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjAxMzAxNzA2MDA1MTI=.jpg"></p>
<p>好丑！！！</p>
<p> </p>
<p>全部代码在<a href="https://github.com/future-challenger/weiboflow" rel="external nofollow noreferrer">这里</a>。</p>
<h4>to be continued</h4>
<p> </p>
<p> <br />
 <br />
<br /> </p>
<p> </p>
<p>欢迎加群互相学习，共同进步。QQ群：iOS: 58099570 | Android: 330987132 | Go：217696290 | Python：336880185 | 做人要厚道，转载请注明出处！http://www.cnblogs.com/sunshine-anycall/p/5171381.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:12:49</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Swift：用UICollectionView整一个瀑布流的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8ZqrZb.html" rel="bookmark">iOS开发之窥探UICollectionViewController&lpar;三&rpar; --使用UICollectionView自定义瀑布流</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上篇博客的实例是自带的UICollectionViewDelegateFlowLayout布局基础上来做的Demo, 详情请看&lt;iOS开发之窥探UICollectionViewController(二) --详解CollectionView各种回调&gt;.UICollectionView之所以强大,是因为其具有自定义功能,这一自定义就不得了啦,自由度非常大,定制的高,所以功能也是灰常强大的.本篇博客就不使用自带的流式布局了,我们要自定义一个瀑布流.自定义的瀑布流可以配置其参数: 每个Cell的边距			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwqdP8M.html" rel="bookmark">一个简单的瀑布流效果&lpar;主体形式自写&rpar;&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				闲着没事,自己写了个瀑布流,我个人写脚本或者是网页的习惯是:只参考别人的效果,很少参考别人的代码,有时侯我宁愿用审查元素来推断代码,也不愿去看源代码.我不知道这个习惯好不好.虽然中间过程是花了我不少时间,但是我做的东西的每一个细节我都还能记清楚(当然肯定后来会忘),因为是我实现的.下面说正题: 瀑布流的主体即为几个ul标签,新增加的元素以 li的形式按照当前 ul的高度有选择性的插入到某个ul下. 主体形式如下: 复制代码 代码如下: &lt;div id=&quot;main&quot;&gt; &lt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/2pL83Lp.html" rel="bookmark">谈淘宝客瀑布流的建站经验分享</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				美丽说蘑菇街火了,方维也火了,和团购市场一样,模版的诞生会引来一个新的电子商务市场的兴起,淘宝客乃这个市场的最大赢家,大小上千家网站竞相争夺电子商务社区的领地,并有知美 花瓣等兴趣图谱类网站的分支诞生,甚至包括人人网也推出了人人逛街,突然间这种瀑布流的网站传遍中华大地... 美丽说蘑菇街火了,方维也火了,和团购市场一样,模版的诞生会引来一个新的电子商务市场的兴起,淘宝客乃这个市场的最大赢家,大小上千家网站竞相争夺电子商务社区的领地,并有知美 花瓣等兴趣图谱类网站的分支诞生,甚至包括人人网也推出了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvGRnrp.html" rel="bookmark">&OpenCurlyDoubleQuote;瀑布流&rdquo;不是万金油 不能忽略网站的设计重点</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在这个以&quot;快速跟进&quot;为发展宗旨的时代,当Pinterest以&quot;瀑布流&quot;的网站布局亮瞎了用户眼球之后,这种布局方式就彻底泛滥了,到处都是尼玛的瀑布流!管你是新创建的还是重新设计的网站,都以Pinterest唯马首是瞻,不带点瀑布范儿都不好意思见人.可是,别人的成功是不可复制的.别以为仅凭一个&quot;瀑布流&quot;就能让你的网站熠熠生辉千秋万代! Pinterest的&quot;瀑布流&quot;布局方式是通过jQuery Masonry插件密集但美观地展示大量			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3o503b.html" rel="bookmark">js-Jquery 瀑布流应用，怎么把它和数据库对接</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Jquery 瀑布流应用,怎么把它和数据库对接 &lt;!doctype html&gt; &lt;html lang=&quot;en&quot;&gt; &lt;head&gt; &lt;meta charset=&quot;utf-8&quot;&gt; &lt;meta http-equiv=&quot;X-UA-Compatible&quot; content=&quot;IE=edge,chrome=1&quot;&gt; &lt;title&gt;jQuery Wookmark P			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqA2g3M.html" rel="bookmark">瀑布流的实现方式（原生js&plus;jquery&plus;css3）&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 项目需求要弄个瀑布流的页面,用的是waterfall这个插件,感觉还是可以的,项目赶就没自己的动手写.最近闲来没事,就自己写个.大致思路理清楚,还是挺好实现的...  原生javascript版  &lt;!DOCTYPE html&gt; &lt;html lang=&quot;en&quot;&gt; &lt;head&gt; &lt;meta charset=&quot;UTF-8&quot;&gt; &lt;title&gt;瀑布流-javascript&lt;/title&gt; &lt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDWkKBp.html" rel="bookmark">瀑布流点击加载更多（记住tomcat下启动，做过瀑布流的大家估计都知道为啥）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				废话不多说,直接上代码:http://download.csdn.net/detail/cometwo/9387665 这个带淡出效果,比较高大上哦:http://download.csdn.net/detail/cometwo/9387971 通过打开/关闭注释235行可以实现自动加载和点击加载更多,是一个瀑布流最经典的例子,完全 适用于各种瀑布流项目 &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; &lt;meta http-equiv=&quot;Co			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJAPgvp.html" rel="bookmark">瀑布流-关于CSS子级float，父级高度变化的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 关于CSS子级float,父级高度变化的问题 网页结构说明: &lt;body&gt; &lt;div id=&quot;header&quot;&gt;...&lt;/div&gt; &lt;div id=&quot;main&quot;&gt; &lt;div id=&quot;left&quot; class=&quot;fleft&quot;&gt;...&lt;/div&gt; &lt;div id=&quot;middle&quot; class=&quot;fleft&quot;&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN8ZYJz.html" rel="bookmark">iOS瀑布流的简单实现&lpar;Swift&rpar;&lowbar;IOS</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这段时间突然想到一个很久之前用到的知识-瀑布流,本来想用一个简单的方法,发现自己走入了歧途,最终只能狠下心来重写UICollectionViewFlowLayout.下面我将用两种方法实现瀑布流,以及会介绍第一种实现的bug. &lt;1&gt;第一种 效果图如下所示: 这种实现方法的思路:  1)首先调用随机函数,产生随机高度,并把它保存到数组中 - (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectio			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVd7QM.html" rel="bookmark" class="title">Henry的VB&period;NET之旅（十一）&mdash;可视继承</a>
					<div>
						继承 Henry的VB.NET之旅(十一)-可视继承 韩睿 闭关修练了一晚上VB.NET的继承程序的我,早上进入公司时自信满满.白经理看到我,问了一句:&quot;学习得怎么样?对VB.NET是不是已 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkKY7p.html" rel="bookmark" class="title">针对搜索结果页（SERPs）对网站进行优化</a>
					<div>
						以前讲了详解谷歌搜索结果页,也对谷歌.百度和Bing的搜索结果页做了些比较.下面就针对搜索引擎的搜索结果页如何对网站进行优化给一些建议.主要有两方面的建议,一是针对网页页面的优化,一是针对网站建设策略 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1R3v3p.html" rel="bookmark" class="title">Dijkstra算法&lpar;二&rpar; C&plus;&plus;详解</a>
					<div>
						迪杰斯特拉算法介绍 迪杰斯特拉(Dijkstra)算法是典型最短路径算法,用于计算一个节点到其他节点的最短路径. 它的主要特点是以起始点为中心向外层层扩展(广度优先搜索思想),直到扩展到终点为止. 基 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62ZKOM.html" rel="bookmark" class="title">Windows XP系统还原及技巧</a>
					<div>
						在Windows XP系统中,我们可以利用系统自带的&quot;系统还原&quot;功能,通过对还原点的设置,记录我们对系统所做的更改,当系统出现故障时,使用系统还原功就能将系统恢复到更改之前的状态. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDA9qBb.html" rel="bookmark" class="title">win7系统网上邻居不见怎么找回？</a>
					<div>
						  win7系统网上邻居不见怎么找回? 从win7系统开始,已经将之前的&quot;网上邻居&quot;改为了&quot;网络&quot;,当然这两者之间的功能基本上是相同的; 方法一: 1.最简单的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M628DLM.html" rel="bookmark" class="title">win8系统中VPN的设置方法</a>
					<div>
						第一步.首先需要在VPN服务站点申请VPN账号,这部分需要读者自己进行探索. 在取得VPN网络账户后,使用步骤与PPPoE宽带接入类似,打开网络和共享中心,在选择连接选项时选择&quot;连接到工作区 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQP7qOz.html" rel="bookmark" class="title">Win8的EFS加密是什么？</a>
					<div>
						  1.右键单击桌面空白处,桌面下方弹出&quot;所有应用&quot;选项,左键单击&quot;所有应用&quot;,参见下图. 2.向右拖动下方滚动条或向下滚动鼠标滚轮键,找到&quot;运行&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5o78ab.html" rel="bookmark" class="title">Mac修改用户名与密码方法</a>
					<div>
						  一.首先点击苹果电脑菜单栏上方的苹果小图标,之后选择&quot;系统偏好设置&quot;设置,如下图所示: Mac系统偏好设置 二.接下来在系统偏好设置中,我们找到&quot;用户与群组&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7E0wM.html" rel="bookmark" class="title">acm问题-Acm 一道数据结构的问题，求思路，不求代码。</a>
					<div>
						问题描述 Acm 一道数据结构的问题,求思路,不求代码. 假设我有两数组,分别有n1 n2个数据(每组数据都不相同).我要两个数组中各取一个相加,有n1乘n2种结果,从小到大排,取前n个.(如果n1  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQLJOp.html" rel="bookmark" class="title">ios-NSInvalidArgumentException引发应用崩溃</a>
					<div>
						问题描述 NSInvalidArgumentException引发应用崩溃 看一下我的代码,从网站服务器获得数据,但是崩溃了: - (void)loadDataSource { // Request  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NdwLM.html" rel="bookmark" class="title">SwipeListView实现仿ios的侧滑</a>
					<div>
						github地址:https://github.com/xiangzhihong/SwipeMenuListView 今天介绍一个SwipeMenuListView实现侧滑删除的例子,其实和listv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7D7Oz.html" rel="bookmark" class="title">js新手跪求这个轮播图怎么自动轮播</a>
					<div>
						问题描述 js新手跪求这个轮播图怎么自动轮播 &lt;script type=&quot;&quot;text/javascript&quot;&quot;&gt; var li_num; var t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjeOep.html" rel="bookmark" class="title">Spring Cloud系列（1）Spring Cloud概述</a>
					<div>
						本站小福利 点我获取阿里云优惠券 原文作者:杨大仙的程序空间 1 Spring Cloud概述         本文要点              传统应用的问题              微服务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2P7xBp.html" rel="bookmark" class="title">android lbs-老师，您好：请教Android定位原理</a>
					<div>
						问题描述 老师,您好:请教Android定位原理 我现在在做的是个Android定位系统,不能用第三方的定位API,像高德.百度等都不能用,我现在除了找到GPS定位能用之外,到目前还没找到其他的合适的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze61rxb.html" rel="bookmark" class="title">java代码怎么写用命令行调用keytool生成证书</a>
					<div>
						问题描述 java代码怎么写用命令行调用keytool生成证书 java代码怎么写用命令行调用keytool生成证书,最好具体一点,有注释最好 解决方案 http://blog.csdn.net/pr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rRB3z.html" rel="bookmark" class="title">急需求助高手</a>
					<div>
						问题描述 我用java写了一个是男人就坚持20秒的小游戏,大体上都写完了,就是运行的时候直接就开始了,我想加一个监听器,当按下回车的时候开始,尝试的加了很多次都没有成功,实在不知道怎么加了,哪位大神有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7B2qp.html" rel="bookmark" class="title">技术-求大神帮忙分许润乾报表或html开发报表功能的优劣不同，谢谢</a>
					<div>
						问题描述 求大神帮忙分许润乾报表或html开发报表功能的优劣不同,谢谢 现在需要开发一个报表模块,有两种方式: 1.调用其他熊也开发好的润乾报表接口,但是本人不会使用润乾报表: 2.直接使用html相 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWJZ5z.html" rel="bookmark" class="title">将xorg和fluxbox程序安装在ARCHlinux中</a>
					<div>
						Xorg是X11的一个实现,而X Window System是一个C/S结构的程序,Xorg只是提供了一个X Server,负责底层的操作当你运行一个程序的时候,这个程序会连接到X server上,由 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8AvLZz.html" rel="bookmark" class="title">专家绘曹操后裔迁移图检测基因有望找到后人</a>
					<div>
						不久前发现的河南安阳曹操墓 日前,复旦大学专家通过史料推演,画出曹操后裔&quot;迁移地图&quot;,基因科学相关检测将在此基础上进一步展开. 曹操并非夏侯之后 传言中,曹操父亲曹嵩原姓夏侯,后来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZLBJM.html" rel="bookmark" class="title">服务器-php连接sql server 出问题</a>
					<div>
						问题描述 php连接sql server 出问题 php5.4.3连接SQL server2008.服务器是IIS.连不上. 我已经把php_pdo_sqlsrv_54_ts.dll和php_sqls ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkeyA7b.html" rel="bookmark" class="title">《OpenACC并行程序设计：性能优化实践指南》一 1&period;4　并行执行和竞争条件</a>
					<div>
						1.4 并行执行和竞争条件 OpenACC并行化for循环(Fortran中是do循环),因此循环内的代码使用并发硬件执行线程并行执行. 循环内的变量i似乎是顺序递增的,但实际上在这个for循环中使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPB3xAb.html" rel="bookmark" class="title">黄雀在后： 安全工具&OpenCurlyDoubleQuote;面部照&rdquo;能秘密拍下入侵你的黑客</a>
					<div>
						本文讲的是 黄雀在后: 安全工具&quot;面部照&quot;能秘密拍下入侵你的黑客,许多人都接到过这样的一封电子邮件,&quot;某人试图登录您的账户--&quot;你是否有过这种经历并百思不得其解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myev9vM.html" rel="bookmark" class="title">Polar码引发舆论狂欢 5G标准远未定局</a>
					<div>
						11月18日,在美国内华达州里诺结束的3GPP的RAN1#87会议上,3GPP确定了Polar码作为5G eMBB(增强移动宽带)场景的控制信道编码方案. Polar码以华为为代表.由中国主导推动,因 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7xXjKb.html" rel="bookmark" class="title">大数据时代的个性化互联网服务解决之道</a>
					<div>
						个性化是商业的未来 现代社会是一个商业社会,工业化解决了批量生产商品的问题,促进商业蓬勃发展.随着社会的不断发展,商品也越来越多样化,以期满足大众的不同需求.以电视机为例,最初只有尺寸的区别,后来可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12vyjp.html" rel="bookmark" class="title">南方日报：品牌美誉度破坏易维护难</a>
					<div>
						品牌美誉度,破坏易维护难 潜望镜 家用电器与老百姓生活息息相关,无论是电视机.洗衣机,还是空调.冰箱.热水器.正是 它们在老百姓的日常生活中发挥着各自重要作用,因此普通消费者对于家用电器品牌好或者坏的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0nKO8z.html" rel="bookmark" class="title">繁体与简体乱码</a>
					<div>
						问题描述 锣盚转寄(这两个都是转寄一个是繁体转gb2312显示的乱码另一个是简体,把繁体转换好啦但是&quot;转寄&quot;又出现乱码啦.)请各位大侠帮俺看看. 解决方案 解决方案二:sofa没明 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12eZ3p.html" rel="bookmark" class="title">鼎晖投资</a>
					<div>
						中文名称:鼎晖投资 英文名称:CDH Investments 网站: http://www.cdhfund.com 总部所在地: 北京 电话: 86-10-65818388 传真: 86-10-658 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ271Yz.html" rel="bookmark" class="title">python的描述符&lpar;descriptor&rpar;、装饰器（property）造成的一个无限递归问题分享&lowbar;python</a>
					<div>
						分享一下刚遇到的一个小问题,我有一段类似于这样的python代码: 复制代码 代码如下: # coding: utf-8 class A(object):     @property     def  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1o8Zb.html" rel="bookmark" class="title">大家在做财务软件的时候用不用ajax&lpar;框架为ajaxpro&rpar;</a>
					<div>
						问题描述 大家在做财务软件的时候用不用ajax(框架为ajaxpro) 解决方案 解决方案二:ajax只是个改善客户体验的方法.不要当作圣经一样对待.在用户注册(检查是否用户名重复)以及一些小地方(但 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Nokxb.html" rel="bookmark" class="title">亿级App陌陌发力移动直播 率先拥抱视频社交</a>
					<div>
						近日,移动社交应用陌陌更新至6.7版本,此次升级最重要的特点就是将&quot;直播&quot;功能提升到了主帧位置,替代了以前的&quot;发现&quot;帧.这使用户可以更便捷的看到陌陌直播上的视频 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.111 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
